searchData={"content_type":"text/markdown","items":[{"doc":"Auto-generated SDK for OpenAI APIs\nSee https://platform.openai.com/docs/api-reference/introduction for further info on REST endpoints\nMake sure to refer to the README on Github to see what is implemented and what isn't yet","ref":"ExOpenAI.html","title":"ExOpenAI","type":"module"},{"doc":"","ref":"ExOpenAI.html#start/2","title":"ExOpenAI.start/2","type":"function"},{"doc":"Modules for interacting with the `assistants` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/assistants","ref":"ExOpenAI.Assistants.html","title":"ExOpenAI.Assistants","type":"module"},{"doc":"Create an assistant with a model and instructions.\n\nEndpoint: `https://api.openai.com/v1/assistants`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#create_assistant/2","title":"ExOpenAI.Assistants.create_assistant/2","type":"function"},{"doc":"- `model`: ID of the model to use. You can use the [List models](https://platform.openai.com/docs/api-reference/models/list) API to see all of your available models, or see our [Model overview](https://platform.openai.com/docs/models/overview) for descriptions of them.\n\n\n\n#","ref":"ExOpenAI.Assistants.html#create_assistant/2-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.create_assistant/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `description`: The description of the assistant. The maximum length is 512 characters.\n\n\n- `file_ids`: A list of [file](https://platform.openai.com/docs/api-reference/files) IDs attached to this assistant. There can be a maximum of 20 files attached to the assistant. Files are ordered by their creation date in ascending order.\n\n\n- `instructions`: The system instructions that the assistant uses. The maximum length is 32768 characters.\n\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `name`: The name of the assistant. The maximum length is 256 characters.\n\n\n- `tools`: A list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types `code_interpreter`, `retrieval`, or `function`.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#create_assistant/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.create_assistant/2","type":"function"},{"doc":"Create an assistant file by attaching a [File](https://platform.openai.com/docs/api-reference/files) to an [assistant](https://platform.openai.com/docs/api-reference/assistants).\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}/files`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#create_assistant_file/3","title":"ExOpenAI.Assistants.create_assistant_file/3","type":"function"},{"doc":"- `assistant_id`\n\n*Example*: `file-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n- `file_id`: A [File](https://platform.openai.com/docs/api-reference/files) ID (with `purpose=\"assistants\"`) that the assistant should use. Useful for tools like `retrieval` and `code_interpreter` that can access files.\n\n\n#","ref":"ExOpenAI.Assistants.html#create_assistant_file/3-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.create_assistant_file/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#create_assistant_file/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.create_assistant_file/3","type":"function"},{"doc":"Delete an assistant.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}`\n\nMethod: DELETE\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#delete_assistant/2","title":"ExOpenAI.Assistants.delete_assistant/2","type":"function"},{"doc":"- `assistant_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#delete_assistant/2-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.delete_assistant/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#delete_assistant/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.delete_assistant/2","type":"function"},{"doc":"Delete an assistant file.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}/files/{file_id}`\n\nMethod: DELETE\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#delete_assistant_file/3","title":"ExOpenAI.Assistants.delete_assistant_file/3","type":"function"},{"doc":"- `assistant_id`\n\n- `file_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#delete_assistant_file/3-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.delete_assistant_file/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#delete_assistant_file/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.delete_assistant_file/3","type":"function"},{"doc":"Retrieves an assistant.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#get_assistant/2","title":"ExOpenAI.Assistants.get_assistant/2","type":"function"},{"doc":"- `assistant_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#get_assistant/2-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.get_assistant/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#get_assistant/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.get_assistant/2","type":"function"},{"doc":"Retrieves an AssistantFile.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}/files/{file_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#get_assistant_file/3","title":"ExOpenAI.Assistants.get_assistant_file/3","type":"function"},{"doc":"- `assistant_id`\n\n- `file_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#get_assistant_file/3-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.get_assistant_file/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#get_assistant_file/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.get_assistant_file/3","type":"function"},{"doc":"Returns a list of assistant files.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}/files`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#list_assistant_files/2","title":"ExOpenAI.Assistants.list_assistant_files/2","type":"function"},{"doc":"- `assistant_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#list_assistant_files/2-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.list_assistant_files/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#list_assistant_files/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.list_assistant_files/2","type":"function"},{"doc":"Returns a list of assistants.\n\nEndpoint: `https://api.openai.com/v1/assistants`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#list_assistants/1","title":"ExOpenAI.Assistants.list_assistants/1","type":"function"},{"doc":"#","ref":"ExOpenAI.Assistants.html#list_assistants/1-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.list_assistants/1","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#list_assistants/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.list_assistants/1","type":"function"},{"doc":"Modifies an assistant.\n\nEndpoint: `https://api.openai.com/v1/assistants/{assistant_id}`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/assistants\n\n---\n\n#","ref":"ExOpenAI.Assistants.html#modify_assistant/2","title":"ExOpenAI.Assistants.modify_assistant/2","type":"function"},{"doc":"- `assistant_id`\n\n\n#","ref":"ExOpenAI.Assistants.html#modify_assistant/2-required-arguments","title":"Required Arguments: - ExOpenAI.Assistants.modify_assistant/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `description`: The description of the assistant. The maximum length is 512 characters.\n\n\n- `file_ids`: A list of [File](https://platform.openai.com/docs/api-reference/files) IDs attached to this assistant. There can be a maximum of 20 files attached to the assistant. Files are ordered by their creation date in ascending order. If a file was previosuly attached to the list but does not show up in the list, it will be deleted from the assistant.\n\n\n- `instructions`: The system instructions that the assistant uses. The maximum length is 32768 characters.\n\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `model`: ID of the model to use. You can use the [List models](https://platform.openai.com/docs/api-reference/models/list) API to see all of your available models, or see our [Model overview](https://platform.openai.com/docs/models/overview) for descriptions of them.\n\n\n- `name`: The name of the assistant. The maximum length is 256 characters.\n\n\n- `tools`: A list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types `code_interpreter`, `retrieval`, or `function`.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Assistants.html#modify_assistant/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Assistants.modify_assistant/2","type":"function"},{"doc":"Modules for interacting with the `audio` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/audio","ref":"ExOpenAI.Audio.html","title":"ExOpenAI.Audio","type":"module"},{"doc":"Generates audio from the input text.\n\nEndpoint: `https://api.openai.com/v1/audio/speech`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/audio\n\n---\n\n#","ref":"ExOpenAI.Audio.html#create_speech/4","title":"ExOpenAI.Audio.create_speech/4","type":"function"},{"doc":"- `input`: The text to generate audio for. The maximum length is 4096 characters.\n\n- `model`: One of the available [TTS models](https://platform.openai.com/docs/models/tts): `tts-1` or `tts-1-hd`\n\n\n- `voice`: The voice to use when generating the audio. Supported voices are `alloy`, `echo`, `fable`, `onyx`, `nova`, and `shimmer`.\n\n\n#","ref":"ExOpenAI.Audio.html#create_speech/4-required-arguments","title":"Required Arguments: - ExOpenAI.Audio.create_speech/4","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `response_format`: The format to audio in. Supported formats are `mp3`, `opus`, `aac`, and `flac`.\n\n- `speed`: The speed of the generated audio. Select a value from `0.25` to `4.0`. `1.0` is the default.\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Audio.html#create_speech/4-optional-arguments","title":"Optional Arguments: - ExOpenAI.Audio.create_speech/4","type":"function"},{"doc":"Transcribes audio into the input language.\n\nEndpoint: `https://api.openai.com/v1/audio/transcriptions`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/audio\n\n---\n\n#","ref":"ExOpenAI.Audio.html#create_transcription/3","title":"ExOpenAI.Audio.create_transcription/3","type":"function"},{"doc":"- `file`: The audio file object (not file name) to transcribe, in one of these formats: flac, mp3, mp4, mpeg, mpga, m4a, ogg, wav, or webm.\n(Pass in a file object created with something like File.open!, or a {filename, file object} tuple to preserve the filename information, eg `{\"filename.ext\", File.open!(\"/tmp/file.ext\")}`)\n\n- `model`: ID of the model to use. Only `whisper-1` is currently available.\n\n\n\n#","ref":"ExOpenAI.Audio.html#create_transcription/3-required-arguments","title":"Required Arguments: - ExOpenAI.Audio.create_transcription/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `language`: The language of the input audio. Supplying the input language in [ISO-639-1](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes) format will improve accuracy and latency.\n\n\n- `prompt`: An optional text to guide the model's style or continue a previous audio segment. The [prompt](https://platform.openai.com/docs/guides/speech-to-text/prompting) should match the audio language.\n\n\n- `response_format`: The format of the transcript output, in one of these options: `json`, `text`, `srt`, `verbose_json`, or `vtt`.\n\n\n- `temperature`: The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use [log probability](https://en.wikipedia.org/wiki/Log_probability) to automatically increase the temperature until certain thresholds are hit.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Audio.html#create_transcription/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Audio.create_transcription/3","type":"function"},{"doc":"Translates audio into English.\n\nEndpoint: `https://api.openai.com/v1/audio/translations`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/audio\n\n---\n\n#","ref":"ExOpenAI.Audio.html#create_translation/3","title":"ExOpenAI.Audio.create_translation/3","type":"function"},{"doc":"- `file`: The audio file object (not file name) translate, in one of these formats: flac, mp3, mp4, mpeg, mpga, m4a, ogg, wav, or webm.\n(Pass in a file object created with something like File.open!, or a {filename, file object} tuple to preserve the filename information, eg `{\"filename.ext\", File.open!(\"/tmp/file.ext\")}`)\n\n- `model`: ID of the model to use. Only `whisper-1` is currently available.\n\n\n\n#","ref":"ExOpenAI.Audio.html#create_translation/3-required-arguments","title":"Required Arguments: - ExOpenAI.Audio.create_translation/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `prompt`: An optional text to guide the model's style or continue a previous audio segment. The [prompt](https://platform.openai.com/docs/guides/speech-to-text/prompting) should be in English.\n\n\n- `response_format`: The format of the transcript output, in one of these options: `json`, `text`, `srt`, `verbose_json`, or `vtt`.\n\n\n- `temperature`: The sampling temperature, between 0 and 1. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. If set to 0, the model will use [log probability](https://en.wikipedia.org/wiki/Log_probability) to automatically increase the temperature until certain thresholds are hit.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Audio.html#create_translation/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Audio.create_translation/3","type":"function"},{"doc":"Modules for interacting with the `chat` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/chat","ref":"ExOpenAI.Chat.html","title":"ExOpenAI.Chat","type":"module"},{"doc":"Creates a model response for the given chat conversation.\n\nEndpoint: `https://api.openai.com/v1/chat/completions`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/chat\n\n---\n\n#","ref":"ExOpenAI.Chat.html#create_chat_completion/3","title":"ExOpenAI.Chat.create_chat_completion/3","type":"function"},{"doc":"- `messages`: A list of messages comprising the conversation so far. [Example Python code](https://cookbook.openai.com/examples/how_to_format_inputs_to_chatgpt_models).\n\n- `model`: ID of the model to use. See the [model endpoint compatibility](https://platform.openai.com/docs/models/model-endpoint-compatibility) table for details on which models work with the Chat API.\n\n\n#","ref":"ExOpenAI.Chat.html#create_chat_completion/3-required-arguments","title":"Required Arguments: - ExOpenAI.Chat.create_chat_completion/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `frequency_penalty`: Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.\n\n[See more information about frequency and presence penalties.](https://platform.openai.com/docs/guides/gpt/parameter-details)\n\n\n- `function_call`: Deprecated in favor of `tool_choice`.\n\nControls which (if any) function is called by the model.\n`none` means the model will not call a function and instead generates a message.\n`auto` means the model can pick between generating a message or calling a function.\nSpecifying a particular function via `{\"name\": \"my_function\"}` forces the model to call that function.\n\n`none` is the default when no functions are present. `auto`` is the default if functions are present.\n\n\n- `functions`: Deprecated in favor of `tools`.\n\nA list of functions the model may generate JSON inputs for.\n\n\n- `logit_bias`: Modify the likelihood of specified tokens appearing in the completion.\n\nAccepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.\n\n\n- `max_tokens`: The maximum number of [tokens](https://platform.openai.com/tokenizer) to generate in the chat completion.\n\nThe total length of input tokens and generated tokens is limited by the model's context length. [Example Python code](https://cookbook.openai.com/examples/how_to_count_tokens_with_tiktoken) for counting tokens.\n\n\n- `n`: How many chat completion choices to generate for each input message.\n\n*Example*: `1`\n\n- `presence_penalty`: Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.\n\n[See more information about frequency and presence penalties.](https://platform.openai.com/docs/guides/gpt/parameter-details)\n\n\n- `response_format`: An object specifying the format that the model must output. \n\nSetting to `{ \"type\": \"json_object\" }` enables JSON mode, which guarantees the message the model generates is valid JSON.\n\n**Important:** when using JSON mode, you **must** also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in increased latency and appearance of a \"stuck\" request. Also note that the message content may be partially cut off if `finish_reason=\"length\"`, which indicates the generation exceeded `max_tokens` or the conversation exceeded the max context length.\n\n\n- `seed`: This feature is in Beta. \nIf specified, our system will make a best effort to sample deterministically, such that repeated requests with the same `seed` and parameters should return the same result.\nDeterminism is not guaranteed, and you should refer to the `system_fingerprint` response parameter to monitor changes in the backend.\n\n\n- `stop`: Up to 4 sequences where the API will stop generating further tokens.\n\n\n- `stream`: If set, partial message deltas will be sent, like in ChatGPT. Tokens will be sent as data-only [server-sent events](https://developer.mozilla.org/en-UShttps://platform.openai.com/docs/Web/API/Server-sent_events/Using_server-sent_events#Event_stream_format) as they become available, with the stream terminated by a `data: [DONE]` message. [Example Python code](https://cookbook.openai.com/examples/how_to_stream_completions).\n\n\n- `temperature`: What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.\n\nWe generally recommend altering this or `top_p` but not both.\n\n\n*Example*: `1`\n\n- `tool_choice`: \n\n- `tools`: A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for.\n\n\n- `top_p`: An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.\n\nWe generally recommend altering this or `temperature` but not both.\n\n\n*Example*: `1`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Chat.html#create_chat_completion/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Chat.create_chat_completion/3","type":"function"},{"doc":"Modules for interacting with the `completions` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/completions","ref":"ExOpenAI.Completions.html","title":"ExOpenAI.Completions","type":"module"},{"doc":"Creates a completion for the provided prompt and parameters.\n\nEndpoint: `https://api.openai.com/v1/completions`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/completions\n\n---\n\n#","ref":"ExOpenAI.Completions.html#create_completion/3","title":"ExOpenAI.Completions.create_completion/3","type":"function"},{"doc":"- `model`: ID of the model to use. You can use the [List models](https://platform.openai.com/docs/api-reference/models/list) API to see all of your available models, or see our [Model overview](https://platform.openai.com/docs/models/overview) for descriptions of them.\n\n\n- `prompt`: The prompt(s) to generate completions for, encoded as a string, array of strings, array of tokens, or array of token arrays.\n\nNote that   is the document separator that the model sees during training, so if a prompt is not specified the model will generate as if from the beginning of a new document.\n\n\n\n#","ref":"ExOpenAI.Completions.html#create_completion/3-required-arguments","title":"Required Arguments: - ExOpenAI.Completions.create_completion/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `best_of`: Generates `best_of` completions server-side and returns the \"best\" (the one with the highest log probability per token). Results cannot be streamed.\n\nWhen used with `n`, `best_of` controls the number of candidate completions and `n` specifies how many to return – `best_of` must be greater than `n`.\n\n**Note:** Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for `max_tokens` and `stop`.\n\n\n- `echo`: Echo back the prompt in addition to the completion\n\n\n- `frequency_penalty`: Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.\n\n[See more information about frequency and presence penalties.](https://platform.openai.com/docs/guides/gpt/parameter-details)\n\n\n- `logit_bias`: Modify the likelihood of specified tokens appearing in the completion.\n\nAccepts a JSON object that maps tokens (specified by their token ID in the GPT tokenizer) to an associated bias value from -100 to 100. You can use this [tokenizer tool](https://platform.openai.com/tokenizer?view=bpe) (which works for both GPT-2 and GPT-3) to convert text to token IDs. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.\n\nAs an example, you can pass `{\"50256\": -100}` to prevent the   token from being generated.\n\n\n- `logprobs`: Include the log probabilities on the `logprobs` most likely tokens, as well the chosen tokens. For example, if `logprobs` is 5, the API will return a list of the 5 most likely tokens. The API will always return the `logprob` of the sampled token, so there may be up to `logprobs+1` elements in the response.\n\nThe maximum value for `logprobs` is 5.\n\n\n- `max_tokens`: The maximum number of [tokens](https://platform.openai.com/tokenizer) to generate in the completion.\n\nThe token count of your prompt plus `max_tokens` cannot exceed the model's context length. [Example Python code](https://cookbook.openai.com/examples/how_to_count_tokens_with_tiktoken) for counting tokens.\n\n\n*Example*: `16`\n\n- `n`: How many completions to generate for each prompt.\n\n**Note:** Because this parameter generates many completions, it can quickly consume your token quota. Use carefully and ensure that you have reasonable settings for `max_tokens` and `stop`.\n\n\n*Example*: `1`\n\n- `presence_penalty`: Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.\n\n[See more information about frequency and presence penalties.](https://platform.openai.com/docs/guides/gpt/parameter-details)\n\n\n- `seed`: If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same `seed` and parameters should return the same result.\n\nDeterminism is not guaranteed, and you should refer to the `system_fingerprint` response parameter to monitor changes in the backend.\n\n\n- `stop`: Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.\n\n\n- `stream`: Whether to stream back partial progress. If set, tokens will be sent as data-only [server-sent events](https://developer.mozilla.org/en-UShttps://platform.openai.com/docs/Web/API/Server-sent_events/Using_server-sent_events#Event_stream_format) as they become available, with the stream terminated by a `data: [DONE]` message. [Example Python code](https://cookbook.openai.com/examples/how_to_stream_completions).\n\n\n- `suffix`: The suffix that comes after a completion of inserted text.\n\n*Example*: `\"test.\"`\n\n- `temperature`: What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.\n\nWe generally recommend altering this or `top_p` but not both.\n\n\n*Example*: `1`\n\n- `top_p`: An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.\n\nWe generally recommend altering this or `temperature` but not both.\n\n\n*Example*: `1`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Completions.html#create_completion/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Completions.create_completion/3","type":"function"},{"doc":"Schema representing a AssistantFileObject within the OpenAI API","ref":"ExOpenAI.Components.AssistantFileObject.html","title":"ExOpenAI.Components.AssistantFileObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.AssistantFileObject.html#t:t/0","title":"ExOpenAI.Components.AssistantFileObject.t/0","type":"type"},{"doc":"Schema representing a AssistantObject within the OpenAI API","ref":"ExOpenAI.Components.AssistantObject.html","title":"ExOpenAI.Components.AssistantObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.AssistantObject.html#t:t/0","title":"ExOpenAI.Components.AssistantObject.t/0","type":"type"},{"doc":"Schema representing a AssistantToolsCode within the OpenAI API","ref":"ExOpenAI.Components.AssistantToolsCode.html","title":"ExOpenAI.Components.AssistantToolsCode","type":"module"},{"doc":"","ref":"ExOpenAI.Components.AssistantToolsCode.html#t:t/0","title":"ExOpenAI.Components.AssistantToolsCode.t/0","type":"type"},{"doc":"Schema representing a AssistantToolsFunction within the OpenAI API","ref":"ExOpenAI.Components.AssistantToolsFunction.html","title":"ExOpenAI.Components.AssistantToolsFunction","type":"module"},{"doc":"","ref":"ExOpenAI.Components.AssistantToolsFunction.html#t:t/0","title":"ExOpenAI.Components.AssistantToolsFunction.t/0","type":"type"},{"doc":"Schema representing a AssistantToolsRetrieval within the OpenAI API","ref":"ExOpenAI.Components.AssistantToolsRetrieval.html","title":"ExOpenAI.Components.AssistantToolsRetrieval","type":"module"},{"doc":"","ref":"ExOpenAI.Components.AssistantToolsRetrieval.html#t:t/0","title":"ExOpenAI.Components.AssistantToolsRetrieval.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionFunctionCallOption within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionFunctionCallOption.html","title":"ExOpenAI.Components.ChatCompletionFunctionCallOption","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionFunctionCallOption.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionFunctionCallOption.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionFunctions within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionFunctions.html","title":"ExOpenAI.Components.ChatCompletionFunctions","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionFunctions.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionFunctions.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionMessageToolCall within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionMessageToolCall.html","title":"ExOpenAI.Components.ChatCompletionMessageToolCall","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionMessageToolCall.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionMessageToolCall.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionMessageToolCallChunk within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionMessageToolCallChunk.html","title":"ExOpenAI.Components.ChatCompletionMessageToolCallChunk","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionMessageToolCallChunk.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionMessageToolCallChunk.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionMessageToolCalls within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionMessageToolCalls.html","title":"ExOpenAI.Components.ChatCompletionMessageToolCalls","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionMessageToolCalls.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionMessageToolCalls.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionNamedToolChoice within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionNamedToolChoice.html","title":"ExOpenAI.Components.ChatCompletionNamedToolChoice","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionNamedToolChoice.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionNamedToolChoice.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestAssistantMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestAssistantMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestAssistantMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestAssistantMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestAssistantMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestFunctionMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestFunctionMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestFunctionMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestFunctionMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestFunctionMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestMessage within the OpenAI API\n\n\n\t\t\t\tUse any of these components: [\"ChatCompletionRequestSystemMessage\", \"ChatCompletionRequestUserMessage\", \"ChatCompletionRequestAssistantMessage\", \"ChatCompletionRequestToolMessage\", \"ChatCompletionRequestFunctionMessage\"]","ref":"ExOpenAI.Components.ChatCompletionRequestMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestMessageContentPart within the OpenAI API\n\n\n\t\t\t\tUse any of these components: [\"ChatCompletionRequestMessageContentPartText\", \"ChatCompletionRequestMessageContentPartImage\"]","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPart.html","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPart","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPart.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPart.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestMessageContentPartImage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartImage.html","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartImage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartImage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartImage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestMessageContentPartText within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartText.html","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartText","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartText.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestMessageContentPartText.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestSystemMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestSystemMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestSystemMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestSystemMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestSystemMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestToolMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestToolMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestToolMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestToolMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestToolMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRequestUserMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRequestUserMessage.html","title":"ExOpenAI.Components.ChatCompletionRequestUserMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRequestUserMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRequestUserMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionResponseMessage within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionResponseMessage.html","title":"ExOpenAI.Components.ChatCompletionResponseMessage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionResponseMessage.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionResponseMessage.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionRole within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionRole.html","title":"ExOpenAI.Components.ChatCompletionRole","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionRole.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionRole.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionStreamResponseDelta within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionStreamResponseDelta.html","title":"ExOpenAI.Components.ChatCompletionStreamResponseDelta","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionStreamResponseDelta.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionStreamResponseDelta.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionTool within the OpenAI API","ref":"ExOpenAI.Components.ChatCompletionTool.html","title":"ExOpenAI.Components.ChatCompletionTool","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionTool.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionTool.t/0","type":"type"},{"doc":"Schema representing a ChatCompletionToolChoiceOption within the OpenAI API\n\n\n\t\t\t\tUse any of these components: [[:none, :auto], \"ChatCompletionNamedToolChoice\"]","ref":"ExOpenAI.Components.ChatCompletionToolChoiceOption.html","title":"ExOpenAI.Components.ChatCompletionToolChoiceOption","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ChatCompletionToolChoiceOption.html#t:t/0","title":"ExOpenAI.Components.ChatCompletionToolChoiceOption.t/0","type":"type"},{"doc":"Schema representing a CompletionUsage within the OpenAI API","ref":"ExOpenAI.Components.CompletionUsage.html","title":"ExOpenAI.Components.CompletionUsage","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CompletionUsage.html#t:t/0","title":"ExOpenAI.Components.CompletionUsage.t/0","type":"type"},{"doc":"Schema representing a CreateAssistantFileRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateAssistantFileRequest.html","title":"ExOpenAI.Components.CreateAssistantFileRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateAssistantFileRequest.html#t:t/0","title":"ExOpenAI.Components.CreateAssistantFileRequest.t/0","type":"type"},{"doc":"Schema representing a CreateAssistantRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateAssistantRequest.html","title":"ExOpenAI.Components.CreateAssistantRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateAssistantRequest.html#t:t/0","title":"ExOpenAI.Components.CreateAssistantRequest.t/0","type":"type"},{"doc":"Schema representing a CreateChatCompletionFunctionResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateChatCompletionFunctionResponse.html","title":"ExOpenAI.Components.CreateChatCompletionFunctionResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateChatCompletionFunctionResponse.html#t:t/0","title":"ExOpenAI.Components.CreateChatCompletionFunctionResponse.t/0","type":"type"},{"doc":"Schema representing a CreateChatCompletionImageResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateChatCompletionImageResponse.html","title":"ExOpenAI.Components.CreateChatCompletionImageResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateChatCompletionImageResponse.html#t:t/0","title":"ExOpenAI.Components.CreateChatCompletionImageResponse.t/0","type":"type"},{"doc":"Schema representing a CreateChatCompletionRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateChatCompletionRequest.html","title":"ExOpenAI.Components.CreateChatCompletionRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateChatCompletionRequest.html#t:t/0","title":"ExOpenAI.Components.CreateChatCompletionRequest.t/0","type":"type"},{"doc":"Schema representing a CreateChatCompletionResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateChatCompletionResponse.html","title":"ExOpenAI.Components.CreateChatCompletionResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateChatCompletionResponse.html#t:t/0","title":"ExOpenAI.Components.CreateChatCompletionResponse.t/0","type":"type"},{"doc":"Schema representing a CreateChatCompletionStreamResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateChatCompletionStreamResponse.html","title":"ExOpenAI.Components.CreateChatCompletionStreamResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateChatCompletionStreamResponse.html#t:t/0","title":"ExOpenAI.Components.CreateChatCompletionStreamResponse.t/0","type":"type"},{"doc":"Schema representing a CreateCompletionRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateCompletionRequest.html","title":"ExOpenAI.Components.CreateCompletionRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateCompletionRequest.html#t:t/0","title":"ExOpenAI.Components.CreateCompletionRequest.t/0","type":"type"},{"doc":"Schema representing a CreateCompletionResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateCompletionResponse.html","title":"ExOpenAI.Components.CreateCompletionResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateCompletionResponse.html#t:t/0","title":"ExOpenAI.Components.CreateCompletionResponse.t/0","type":"type"},{"doc":"Schema representing a CreateEditRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateEditRequest.html","title":"ExOpenAI.Components.CreateEditRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateEditRequest.html#t:t/0","title":"ExOpenAI.Components.CreateEditRequest.t/0","type":"type"},{"doc":"Schema representing a CreateEditResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateEditResponse.html","title":"ExOpenAI.Components.CreateEditResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateEditResponse.html#t:t/0","title":"ExOpenAI.Components.CreateEditResponse.t/0","type":"type"},{"doc":"Schema representing a CreateEmbeddingRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateEmbeddingRequest.html","title":"ExOpenAI.Components.CreateEmbeddingRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateEmbeddingRequest.html#t:t/0","title":"ExOpenAI.Components.CreateEmbeddingRequest.t/0","type":"type"},{"doc":"Schema representing a CreateEmbeddingResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateEmbeddingResponse.html","title":"ExOpenAI.Components.CreateEmbeddingResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateEmbeddingResponse.html#t:t/0","title":"ExOpenAI.Components.CreateEmbeddingResponse.t/0","type":"type"},{"doc":"Schema representing a CreateFileRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateFileRequest.html","title":"ExOpenAI.Components.CreateFileRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateFileRequest.html#t:t/0","title":"ExOpenAI.Components.CreateFileRequest.t/0","type":"type"},{"doc":"Schema representing a CreateFineTuneRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateFineTuneRequest.html","title":"ExOpenAI.Components.CreateFineTuneRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateFineTuneRequest.html#t:t/0","title":"ExOpenAI.Components.CreateFineTuneRequest.t/0","type":"type"},{"doc":"Schema representing a CreateFineTuningJobRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateFineTuningJobRequest.html","title":"ExOpenAI.Components.CreateFineTuningJobRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateFineTuningJobRequest.html#t:t/0","title":"ExOpenAI.Components.CreateFineTuningJobRequest.t/0","type":"type"},{"doc":"Schema representing a CreateImageEditRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateImageEditRequest.html","title":"ExOpenAI.Components.CreateImageEditRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateImageEditRequest.html#t:t/0","title":"ExOpenAI.Components.CreateImageEditRequest.t/0","type":"type"},{"doc":"Schema representing a CreateImageRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateImageRequest.html","title":"ExOpenAI.Components.CreateImageRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateImageRequest.html#t:t/0","title":"ExOpenAI.Components.CreateImageRequest.t/0","type":"type"},{"doc":"Schema representing a CreateImageVariationRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateImageVariationRequest.html","title":"ExOpenAI.Components.CreateImageVariationRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateImageVariationRequest.html#t:t/0","title":"ExOpenAI.Components.CreateImageVariationRequest.t/0","type":"type"},{"doc":"Schema representing a CreateMessageRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateMessageRequest.html","title":"ExOpenAI.Components.CreateMessageRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateMessageRequest.html#t:t/0","title":"ExOpenAI.Components.CreateMessageRequest.t/0","type":"type"},{"doc":"Schema representing a CreateModerationRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateModerationRequest.html","title":"ExOpenAI.Components.CreateModerationRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateModerationRequest.html#t:t/0","title":"ExOpenAI.Components.CreateModerationRequest.t/0","type":"type"},{"doc":"Schema representing a CreateModerationResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateModerationResponse.html","title":"ExOpenAI.Components.CreateModerationResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateModerationResponse.html#t:t/0","title":"ExOpenAI.Components.CreateModerationResponse.t/0","type":"type"},{"doc":"Schema representing a CreateRunRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateRunRequest.html","title":"ExOpenAI.Components.CreateRunRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateRunRequest.html#t:t/0","title":"ExOpenAI.Components.CreateRunRequest.t/0","type":"type"},{"doc":"Schema representing a CreateSpeechRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateSpeechRequest.html","title":"ExOpenAI.Components.CreateSpeechRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateSpeechRequest.html#t:t/0","title":"ExOpenAI.Components.CreateSpeechRequest.t/0","type":"type"},{"doc":"Schema representing a CreateThreadAndRunRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateThreadAndRunRequest.html","title":"ExOpenAI.Components.CreateThreadAndRunRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateThreadAndRunRequest.html#t:t/0","title":"ExOpenAI.Components.CreateThreadAndRunRequest.t/0","type":"type"},{"doc":"Schema representing a CreateThreadRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateThreadRequest.html","title":"ExOpenAI.Components.CreateThreadRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateThreadRequest.html#t:t/0","title":"ExOpenAI.Components.CreateThreadRequest.t/0","type":"type"},{"doc":"Schema representing a CreateTranscriptionRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateTranscriptionRequest.html","title":"ExOpenAI.Components.CreateTranscriptionRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateTranscriptionRequest.html#t:t/0","title":"ExOpenAI.Components.CreateTranscriptionRequest.t/0","type":"type"},{"doc":"Schema representing a CreateTranscriptionResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateTranscriptionResponse.html","title":"ExOpenAI.Components.CreateTranscriptionResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateTranscriptionResponse.html#t:t/0","title":"ExOpenAI.Components.CreateTranscriptionResponse.t/0","type":"type"},{"doc":"Schema representing a CreateTranslationRequest within the OpenAI API","ref":"ExOpenAI.Components.CreateTranslationRequest.html","title":"ExOpenAI.Components.CreateTranslationRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateTranslationRequest.html#t:t/0","title":"ExOpenAI.Components.CreateTranslationRequest.t/0","type":"type"},{"doc":"Schema representing a CreateTranslationResponse within the OpenAI API","ref":"ExOpenAI.Components.CreateTranslationResponse.html","title":"ExOpenAI.Components.CreateTranslationResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.CreateTranslationResponse.html#t:t/0","title":"ExOpenAI.Components.CreateTranslationResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteAssistantFileResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteAssistantFileResponse.html","title":"ExOpenAI.Components.DeleteAssistantFileResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteAssistantFileResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteAssistantFileResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteAssistantResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteAssistantResponse.html","title":"ExOpenAI.Components.DeleteAssistantResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteAssistantResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteAssistantResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteFileResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteFileResponse.html","title":"ExOpenAI.Components.DeleteFileResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteFileResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteFileResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteMessageResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteMessageResponse.html","title":"ExOpenAI.Components.DeleteMessageResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteMessageResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteMessageResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteModelResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteModelResponse.html","title":"ExOpenAI.Components.DeleteModelResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteModelResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteModelResponse.t/0","type":"type"},{"doc":"Schema representing a DeleteThreadResponse within the OpenAI API","ref":"ExOpenAI.Components.DeleteThreadResponse.html","title":"ExOpenAI.Components.DeleteThreadResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.DeleteThreadResponse.html#t:t/0","title":"ExOpenAI.Components.DeleteThreadResponse.t/0","type":"type"},{"doc":"Schema representing a Embedding within the OpenAI API","ref":"ExOpenAI.Components.Embedding.html","title":"ExOpenAI.Components.Embedding","type":"module"},{"doc":"","ref":"ExOpenAI.Components.Embedding.html#t:t/0","title":"ExOpenAI.Components.Embedding.t/0","type":"type"},{"doc":"Schema representing a Error within the OpenAI API","ref":"ExOpenAI.Components.Error.html","title":"ExOpenAI.Components.Error","type":"module"},{"doc":"","ref":"ExOpenAI.Components.Error.html#t:t/0","title":"ExOpenAI.Components.Error.t/0","type":"type"},{"doc":"Schema representing a ErrorResponse within the OpenAI API","ref":"ExOpenAI.Components.ErrorResponse.html","title":"ExOpenAI.Components.ErrorResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ErrorResponse.html#t:t/0","title":"ExOpenAI.Components.ErrorResponse.t/0","type":"type"},{"doc":"Schema representing a FineTune within the OpenAI API","ref":"ExOpenAI.Components.FineTune.html","title":"ExOpenAI.Components.FineTune","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FineTune.html#t:t/0","title":"ExOpenAI.Components.FineTune.t/0","type":"type"},{"doc":"Schema representing a FineTuneEvent within the OpenAI API","ref":"ExOpenAI.Components.FineTuneEvent.html","title":"ExOpenAI.Components.FineTuneEvent","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FineTuneEvent.html#t:t/0","title":"ExOpenAI.Components.FineTuneEvent.t/0","type":"type"},{"doc":"Schema representing a FineTuningJob within the OpenAI API","ref":"ExOpenAI.Components.FineTuningJob.html","title":"ExOpenAI.Components.FineTuningJob","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FineTuningJob.html#t:t/0","title":"ExOpenAI.Components.FineTuningJob.t/0","type":"type"},{"doc":"Schema representing a FineTuningJobEvent within the OpenAI API","ref":"ExOpenAI.Components.FineTuningJobEvent.html","title":"ExOpenAI.Components.FineTuningJobEvent","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FineTuningJobEvent.html#t:t/0","title":"ExOpenAI.Components.FineTuningJobEvent.t/0","type":"type"},{"doc":"Schema representing a FunctionObject within the OpenAI API","ref":"ExOpenAI.Components.FunctionObject.html","title":"ExOpenAI.Components.FunctionObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FunctionObject.html#t:t/0","title":"ExOpenAI.Components.FunctionObject.t/0","type":"type"},{"doc":"Schema representing a FunctionParameters within the OpenAI API","ref":"ExOpenAI.Components.FunctionParameters.html","title":"ExOpenAI.Components.FunctionParameters","type":"module"},{"doc":"","ref":"ExOpenAI.Components.FunctionParameters.html#t:t/0","title":"ExOpenAI.Components.FunctionParameters.t/0","type":"type"},{"doc":"Schema representing a Image within the OpenAI API","ref":"ExOpenAI.Components.Image.html","title":"ExOpenAI.Components.Image","type":"module"},{"doc":"","ref":"ExOpenAI.Components.Image.html#t:t/0","title":"ExOpenAI.Components.Image.t/0","type":"type"},{"doc":"Schema representing a ImagesResponse within the OpenAI API","ref":"ExOpenAI.Components.ImagesResponse.html","title":"ExOpenAI.Components.ImagesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ImagesResponse.html#t:t/0","title":"ExOpenAI.Components.ImagesResponse.t/0","type":"type"},{"doc":"Schema representing a ListAssistantFilesResponse within the OpenAI API","ref":"ExOpenAI.Components.ListAssistantFilesResponse.html","title":"ExOpenAI.Components.ListAssistantFilesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListAssistantFilesResponse.html#t:t/0","title":"ExOpenAI.Components.ListAssistantFilesResponse.t/0","type":"type"},{"doc":"Schema representing a ListAssistantsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListAssistantsResponse.html","title":"ExOpenAI.Components.ListAssistantsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListAssistantsResponse.html#t:t/0","title":"ExOpenAI.Components.ListAssistantsResponse.t/0","type":"type"},{"doc":"Schema representing a ListFilesResponse within the OpenAI API","ref":"ExOpenAI.Components.ListFilesResponse.html","title":"ExOpenAI.Components.ListFilesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListFilesResponse.html#t:t/0","title":"ExOpenAI.Components.ListFilesResponse.t/0","type":"type"},{"doc":"Schema representing a ListFineTuneEventsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListFineTuneEventsResponse.html","title":"ExOpenAI.Components.ListFineTuneEventsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListFineTuneEventsResponse.html#t:t/0","title":"ExOpenAI.Components.ListFineTuneEventsResponse.t/0","type":"type"},{"doc":"Schema representing a ListFineTunesResponse within the OpenAI API","ref":"ExOpenAI.Components.ListFineTunesResponse.html","title":"ExOpenAI.Components.ListFineTunesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListFineTunesResponse.html#t:t/0","title":"ExOpenAI.Components.ListFineTunesResponse.t/0","type":"type"},{"doc":"Schema representing a ListFineTuningJobEventsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListFineTuningJobEventsResponse.html","title":"ExOpenAI.Components.ListFineTuningJobEventsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListFineTuningJobEventsResponse.html#t:t/0","title":"ExOpenAI.Components.ListFineTuningJobEventsResponse.t/0","type":"type"},{"doc":"Schema representing a ListMessageFilesResponse within the OpenAI API","ref":"ExOpenAI.Components.ListMessageFilesResponse.html","title":"ExOpenAI.Components.ListMessageFilesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListMessageFilesResponse.html#t:t/0","title":"ExOpenAI.Components.ListMessageFilesResponse.t/0","type":"type"},{"doc":"Schema representing a ListMessagesResponse within the OpenAI API","ref":"ExOpenAI.Components.ListMessagesResponse.html","title":"ExOpenAI.Components.ListMessagesResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListMessagesResponse.html#t:t/0","title":"ExOpenAI.Components.ListMessagesResponse.t/0","type":"type"},{"doc":"Schema representing a ListModelsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListModelsResponse.html","title":"ExOpenAI.Components.ListModelsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListModelsResponse.html#t:t/0","title":"ExOpenAI.Components.ListModelsResponse.t/0","type":"type"},{"doc":"Schema representing a ListPaginatedFineTuningJobsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListPaginatedFineTuningJobsResponse.html","title":"ExOpenAI.Components.ListPaginatedFineTuningJobsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListPaginatedFineTuningJobsResponse.html#t:t/0","title":"ExOpenAI.Components.ListPaginatedFineTuningJobsResponse.t/0","type":"type"},{"doc":"Schema representing a ListRunStepsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListRunStepsResponse.html","title":"ExOpenAI.Components.ListRunStepsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListRunStepsResponse.html#t:t/0","title":"ExOpenAI.Components.ListRunStepsResponse.t/0","type":"type"},{"doc":"Schema representing a ListRunsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListRunsResponse.html","title":"ExOpenAI.Components.ListRunsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListRunsResponse.html#t:t/0","title":"ExOpenAI.Components.ListRunsResponse.t/0","type":"type"},{"doc":"Schema representing a ListThreadsResponse within the OpenAI API","ref":"ExOpenAI.Components.ListThreadsResponse.html","title":"ExOpenAI.Components.ListThreadsResponse","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ListThreadsResponse.html#t:t/0","title":"ExOpenAI.Components.ListThreadsResponse.t/0","type":"type"},{"doc":"Schema representing a MessageContentImageFileObject within the OpenAI API","ref":"ExOpenAI.Components.MessageContentImageFileObject.html","title":"ExOpenAI.Components.MessageContentImageFileObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageContentImageFileObject.html#t:t/0","title":"ExOpenAI.Components.MessageContentImageFileObject.t/0","type":"type"},{"doc":"Schema representing a MessageContentTextAnnotationsFileCitationObject within the OpenAI API","ref":"ExOpenAI.Components.MessageContentTextAnnotationsFileCitationObject.html","title":"ExOpenAI.Components.MessageContentTextAnnotationsFileCitationObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageContentTextAnnotationsFileCitationObject.html#t:t/0","title":"ExOpenAI.Components.MessageContentTextAnnotationsFileCitationObject.t/0","type":"type"},{"doc":"Schema representing a MessageContentTextAnnotationsFilePathObject within the OpenAI API","ref":"ExOpenAI.Components.MessageContentTextAnnotationsFilePathObject.html","title":"ExOpenAI.Components.MessageContentTextAnnotationsFilePathObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageContentTextAnnotationsFilePathObject.html#t:t/0","title":"ExOpenAI.Components.MessageContentTextAnnotationsFilePathObject.t/0","type":"type"},{"doc":"Schema representing a MessageContentTextObject within the OpenAI API","ref":"ExOpenAI.Components.MessageContentTextObject.html","title":"ExOpenAI.Components.MessageContentTextObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageContentTextObject.html#t:t/0","title":"ExOpenAI.Components.MessageContentTextObject.t/0","type":"type"},{"doc":"Schema representing a MessageFileObject within the OpenAI API","ref":"ExOpenAI.Components.MessageFileObject.html","title":"ExOpenAI.Components.MessageFileObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageFileObject.html#t:t/0","title":"ExOpenAI.Components.MessageFileObject.t/0","type":"type"},{"doc":"Schema representing a MessageObject within the OpenAI API","ref":"ExOpenAI.Components.MessageObject.html","title":"ExOpenAI.Components.MessageObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.MessageObject.html#t:t/0","title":"ExOpenAI.Components.MessageObject.t/0","type":"type"},{"doc":"Replacement Component for Model API responses\nThis module was not part of the api documentation and got probably forgotten, so it has been manually provided by this package\nRpresents API responses such as:\n```\ncreated: 1649880484,\nid: \"text-davinci-insert-002\",\nobject: \"model\",\nowned_by: \"openai\",\nparent: nil,\npermission: [\n  %{\n    allow_create_engine: false,\n    allow_fine_tuning: false,\n    allow_logprobs: true,\n    allow_sampling: true,\n    allow_search_indices: false,\n    allow_view: true,\n    created: 1669066354,\n    group: nil,\n    id: \"modelperm-V5YQoSyiapAf4km5wisXkNXh\",\n    is_blocking: false,\n    object: \"model_permission\",\n    organization: \"*\"\n  }\n],\nroot: \"text-davinci-insert-002\"\n```","ref":"ExOpenAI.Components.Model.html","title":"ExOpenAI.Components.Model","type":"module"},{"doc":"","ref":"ExOpenAI.Components.Model.html#t:t/0","title":"ExOpenAI.Components.Model.t/0","type":"type"},{"doc":"Schema representing a ModifyAssistantRequest within the OpenAI API","ref":"ExOpenAI.Components.ModifyAssistantRequest.html","title":"ExOpenAI.Components.ModifyAssistantRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ModifyAssistantRequest.html#t:t/0","title":"ExOpenAI.Components.ModifyAssistantRequest.t/0","type":"type"},{"doc":"Schema representing a ModifyMessageRequest within the OpenAI API","ref":"ExOpenAI.Components.ModifyMessageRequest.html","title":"ExOpenAI.Components.ModifyMessageRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ModifyMessageRequest.html#t:t/0","title":"ExOpenAI.Components.ModifyMessageRequest.t/0","type":"type"},{"doc":"Schema representing a ModifyRunRequest within the OpenAI API","ref":"ExOpenAI.Components.ModifyRunRequest.html","title":"ExOpenAI.Components.ModifyRunRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ModifyRunRequest.html#t:t/0","title":"ExOpenAI.Components.ModifyRunRequest.t/0","type":"type"},{"doc":"Schema representing a ModifyThreadRequest within the OpenAI API","ref":"ExOpenAI.Components.ModifyThreadRequest.html","title":"ExOpenAI.Components.ModifyThreadRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ModifyThreadRequest.html#t:t/0","title":"ExOpenAI.Components.ModifyThreadRequest.t/0","type":"type"},{"doc":"Schema representing a OpenAIFile within the OpenAI API","ref":"ExOpenAI.Components.OpenAIFile.html","title":"ExOpenAI.Components.OpenAIFile","type":"module"},{"doc":"","ref":"ExOpenAI.Components.OpenAIFile.html#t:t/0","title":"ExOpenAI.Components.OpenAIFile.t/0","type":"type"},{"doc":"Schema representing a RunObject within the OpenAI API","ref":"ExOpenAI.Components.RunObject.html","title":"ExOpenAI.Components.RunObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunObject.html#t:t/0","title":"ExOpenAI.Components.RunObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsMessageCreationObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsMessageCreationObject.html","title":"ExOpenAI.Components.RunStepDetailsMessageCreationObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsMessageCreationObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsMessageCreationObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsCodeObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsCodeOutputImageObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputImageObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputImageObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputImageObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputImageObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsCodeOutputLogsObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputLogsObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputLogsObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputLogsObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsCodeOutputLogsObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsFunctionObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsFunctionObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsFunctionObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsFunctionObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsFunctionObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsObject.t/0","type":"type"},{"doc":"Schema representing a RunStepDetailsToolCallsRetrievalObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepDetailsToolCallsRetrievalObject.html","title":"ExOpenAI.Components.RunStepDetailsToolCallsRetrievalObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepDetailsToolCallsRetrievalObject.html#t:t/0","title":"ExOpenAI.Components.RunStepDetailsToolCallsRetrievalObject.t/0","type":"type"},{"doc":"Schema representing a RunStepObject within the OpenAI API","ref":"ExOpenAI.Components.RunStepObject.html","title":"ExOpenAI.Components.RunStepObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunStepObject.html#t:t/0","title":"ExOpenAI.Components.RunStepObject.t/0","type":"type"},{"doc":"Schema representing a RunToolCallObject within the OpenAI API","ref":"ExOpenAI.Components.RunToolCallObject.html","title":"ExOpenAI.Components.RunToolCallObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.RunToolCallObject.html#t:t/0","title":"ExOpenAI.Components.RunToolCallObject.t/0","type":"type"},{"doc":"Schema representing a SubmitToolOutputsRunRequest within the OpenAI API","ref":"ExOpenAI.Components.SubmitToolOutputsRunRequest.html","title":"ExOpenAI.Components.SubmitToolOutputsRunRequest","type":"module"},{"doc":"","ref":"ExOpenAI.Components.SubmitToolOutputsRunRequest.html#t:t/0","title":"ExOpenAI.Components.SubmitToolOutputsRunRequest.t/0","type":"type"},{"doc":"Schema representing a ThreadObject within the OpenAI API","ref":"ExOpenAI.Components.ThreadObject.html","title":"ExOpenAI.Components.ThreadObject","type":"module"},{"doc":"","ref":"ExOpenAI.Components.ThreadObject.html#t:t/0","title":"ExOpenAI.Components.ThreadObject.t/0","type":"type"},{"doc":"Reads configuration on application start, parses all environment variables (if any)\nand caches the final config in memory to avoid parsing on each read afterwards.","ref":"ExOpenAI.Config.html","title":"ExOpenAI.Config","type":"module"},{"doc":"","ref":"ExOpenAI.Config.html#api_key/0","title":"ExOpenAI.Config.api_key/0","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#api_url/0","title":"ExOpenAI.Config.api_url/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOpenAI.Config.html#child_spec/1","title":"ExOpenAI.Config.child_spec/1","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#get/1","title":"ExOpenAI.Config.get/1","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#http_headers/0","title":"ExOpenAI.Config.http_headers/0","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#http_options/0","title":"ExOpenAI.Config.http_options/0","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#org_key/0","title":"ExOpenAI.Config.org_key/0","type":"function"},{"doc":"","ref":"ExOpenAI.Config.html#start_link/1","title":"ExOpenAI.Config.start_link/1","type":"function"},{"doc":"Modules for interacting with the `edits` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/edits","ref":"ExOpenAI.Edits.html","title":"ExOpenAI.Edits","type":"module"},{"doc":"Creates a new edit for the provided input, instruction, and parameters.\n\nEndpoint: `https://api.openai.com/v1/edits`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/edits\n\n---\n\n#","ref":"ExOpenAI.Edits.html#create_edit/3","title":"ExOpenAI.Edits.create_edit/3","type":"function"},{"doc":"- `instruction`: The instruction that tells the model how to edit the prompt.\n\n*Example*: `Fix the spelling mistakes.`\n\n- `model`: ID of the model to use. You can use the `text-davinci-edit-001` or `code-davinci-edit-001` model with this endpoint.\n\n\n#","ref":"ExOpenAI.Edits.html#create_edit/3-required-arguments","title":"Required Arguments: - ExOpenAI.Edits.create_edit/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `input`: The input text to use as a starting point for the edit.\n\n*Example*: `\"What day of the wek is it?\"`\n\n- `n`: How many edits to generate for the input and instruction.\n\n*Example*: `1`\n\n- `temperature`: What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.\n\nWe generally recommend altering this or `top_p` but not both.\n\n\n*Example*: `1`\n\n- `top_p`: An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.\n\nWe generally recommend altering this or `temperature` but not both.\n\n\n*Example*: `1`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Edits.html#create_edit/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Edits.create_edit/3","type":"function"},{"doc":"Modules for interacting with the `embeddings` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/embeddings","ref":"ExOpenAI.Embeddings.html","title":"ExOpenAI.Embeddings","type":"module"},{"doc":"Creates an embedding vector representing the input text.\n\nEndpoint: `https://api.openai.com/v1/embeddings`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/embeddings\n\n---\n\n#","ref":"ExOpenAI.Embeddings.html#create_embedding/3","title":"ExOpenAI.Embeddings.create_embedding/3","type":"function"},{"doc":"- `input`: Input text to embed, encoded as a string or array of tokens. To embed multiple inputs in a single request, pass an array of strings or array of token arrays. The input must not exceed the max input tokens for the model (8192 tokens for `text-embedding-ada-002`) and cannot be an empty string. [Example Python code](https://cookbook.openai.com/examples/how_to_count_tokens_with_tiktoken) for counting tokens.\n\n\n- `model`: ID of the model to use. You can use the [List models](https://platform.openai.com/docs/api-reference/models/list) API to see all of your available models, or see our [Model overview](https://platform.openai.com/docs/models/overview) for descriptions of them.\n\n\n\n#","ref":"ExOpenAI.Embeddings.html#create_embedding/3-required-arguments","title":"Required Arguments: - ExOpenAI.Embeddings.create_embedding/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `encoding_format`: The format to return the embeddings in. Can be either `float` or [`base64`](https://pypi.org/project/pybase64/).\n\n*Example*: `\"float\"`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Embeddings.html#create_embedding/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Embeddings.create_embedding/3","type":"function"},{"doc":"Modules for interacting with the `files` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/files","ref":"ExOpenAI.Files.html","title":"ExOpenAI.Files","type":"module"},{"doc":"Upload a file that can be used across various endpoints/features. The size of all the files uploaded by one organization can be up to 100 GB.\n\nThe size of individual files for can be a maximum of 512MB. See the [Assistants Tools guide](https://platform.openai.com/docs/assistants/tools) to learn more about the types of files supported. The Fine-tuning API only supports `.jsonl` files.\n\nPlease [contact us](https://help.openai.com/) if you need to increase these storage limits.\n\n\nEndpoint: `https://api.openai.com/v1/files`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/files\n\n---\n\n#","ref":"ExOpenAI.Files.html#create_file/3","title":"ExOpenAI.Files.create_file/3","type":"function"},{"doc":"- `file`: The File object (not file name) to be uploaded.\n(Pass in a file object created with something like File.open!, or a {filename, file object} tuple to preserve the filename information, eg `{\"filename.ext\", File.open!(\"/tmp/file.ext\")}`)\n\n- `purpose`: The intended purpose of the uploaded file.\n\nUse \"fine-tune\" for [Fine-tuning](https://platform.openai.com/docs/api-reference/fine-tuning) and \"assistants\" for [Assistants](https://platform.openai.com/docs/api-reference/assistants) and [Messages](https://platform.openai.com/docs/api-reference/messages). This allows us to validate the format of the uploaded file is correct for fine-tuning.\n\n\n\n#","ref":"ExOpenAI.Files.html#create_file/3-required-arguments","title":"Required Arguments: - ExOpenAI.Files.create_file/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Files.html#create_file/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Files.create_file/3","type":"function"},{"doc":"Delete a file.\n\nEndpoint: `https://api.openai.com/v1/files/{file_id}`\n\nMethod: DELETE\n\nDocs: https://platform.openai.com/docs/api-reference/files\n\n---\n\n#","ref":"ExOpenAI.Files.html#delete_file/2","title":"ExOpenAI.Files.delete_file/2","type":"function"},{"doc":"- `file_id`\n\n\n#","ref":"ExOpenAI.Files.html#delete_file/2-required-arguments","title":"Required Arguments: - ExOpenAI.Files.delete_file/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Files.html#delete_file/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Files.delete_file/2","type":"function"},{"doc":"Returns the contents of the specified file.\n\nEndpoint: `https://api.openai.com/v1/files/{file_id}/content`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/files\n\n---\n\n#","ref":"ExOpenAI.Files.html#download_file/2","title":"ExOpenAI.Files.download_file/2","type":"function"},{"doc":"- `file_id`\n\n\n#","ref":"ExOpenAI.Files.html#download_file/2-required-arguments","title":"Required Arguments: - ExOpenAI.Files.download_file/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Files.html#download_file/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Files.download_file/2","type":"function"},{"doc":"Returns a list of files that belong to the user's organization.\n\nEndpoint: `https://api.openai.com/v1/files`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/files\n\n---\n\n#","ref":"ExOpenAI.Files.html#list_files/1","title":"ExOpenAI.Files.list_files/1","type":"function"},{"doc":"#","ref":"ExOpenAI.Files.html#list_files/1-required-arguments","title":"Required Arguments: - ExOpenAI.Files.list_files/1","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `purpose`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Files.html#list_files/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.Files.list_files/1","type":"function"},{"doc":"Returns information about a specific file.\n\nEndpoint: `https://api.openai.com/v1/files/{file_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/files\n\n---\n\n#","ref":"ExOpenAI.Files.html#retrieve_file/2","title":"ExOpenAI.Files.retrieve_file/2","type":"function"},{"doc":"- `file_id`\n\n\n#","ref":"ExOpenAI.Files.html#retrieve_file/2-required-arguments","title":"Required Arguments: - ExOpenAI.Files.retrieve_file/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Files.html#retrieve_file/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Files.retrieve_file/2","type":"function"},{"doc":"Modules for interacting with the `fine_tunes` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/fine_tunes","ref":"ExOpenAI.FineTunes.html","title":"ExOpenAI.FineTunes","type":"module"},{"doc":"Immediately cancel a fine-tune job.\n\n\nEndpoint: `https://api.openai.com/v1/fine-tunes/{fine_tune_id}/cancel`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tunes\n\n---\n\n#","ref":"ExOpenAI.FineTunes.html#cancel_fine_tune/2","title":"ExOpenAI.FineTunes.cancel_fine_tune/2","type":"function"},{"doc":"- `fine_tune_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTunes.html#cancel_fine_tune/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTunes.cancel_fine_tune/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTunes.html#cancel_fine_tune/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTunes.cancel_fine_tune/2","type":"function"},{"doc":"Creates a job that fine-tunes a specified model from a given dataset.\n\nResponse includes details of the enqueued job including job status and the name of the fine-tuned models once complete.\n\n[Learn more about fine-tuning](https://platform.openai.com/docs/guides/legacy-fine-tuning)\n\n\nEndpoint: `https://api.openai.com/v1/fine-tunes`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tunes\n\n---\n\n#","ref":"ExOpenAI.FineTunes.html#create_fine_tune/2","title":"ExOpenAI.FineTunes.create_fine_tune/2","type":"function"},{"doc":"- `training_file`: The ID of an uploaded file that contains training data.\n\nSee [upload file](https://platform.openai.com/docs/api-reference/files/upload) for how to upload a file.\n\nYour dataset must be formatted as a JSONL file, where each training\nexample is a JSON object with the keys \"prompt\" and \"completion\".\nAdditionally, you must upload your file with the purpose `fine-tune`.\n\nSee the [fine-tuning guide](https://platform.openai.com/docs/guides/legacy-fine-tuning/creating-training-data) for more details.\n\n\n*Example*: `file-abc123`\n\n\n#","ref":"ExOpenAI.FineTunes.html#create_fine_tune/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTunes.create_fine_tune/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `batch_size`: The batch size to use for training. The batch size is the number of\ntraining examples used to train a single forward and backward pass.\n\nBy default, the batch size will be dynamically configured to be\n~0.2% of the number of examples in the training set, capped at 256 -\nin general, we've found that larger batch sizes tend to work better\nfor larger datasets.\n\n\n- `classification_betas`: If this is provided, we calculate F-beta scores at the specified\nbeta values. The F-beta score is a generalization of F-1 score.\nThis is only used for binary classification.\n\nWith a beta of 1 (i.e. the F-1 score), precision and recall are\ngiven the same weight. A larger beta score puts more weight on\nrecall and less on precision. A smaller beta score puts more weight\non precision and less on recall.\n\n\n*Example*: `[0.6, 1, 1.5, 2]`\n\n- `classification_n_classes`: The number of classes in a classification task.\n\nThis parameter is required for multiclass classification.\n\n\n- `classification_positive_class`: The positive class in binary classification.\n\nThis parameter is needed to generate precision, recall, and F1\nmetrics when doing binary classification.\n\n\n- `compute_classification_metrics`: If set, we calculate classification-specific metrics such as accuracy\nand F-1 score using the validation set at the end of every epoch.\nThese metrics can be viewed in the [results file](https://platform.openai.com/docs/guides/legacy-fine-tuning/analyzing-your-fine-tuned-model).\n\nIn order to compute classification metrics, you must provide a\n`validation_file`. Additionally, you must\nspecify `classification_n_classes` for multiclass classification or\n`classification_positive_class` for binary classification.\n\n\n- `hyperparameters`: The hyperparameters used for the fine-tuning job.\n\n- `learning_rate_multiplier`: The learning rate multiplier to use for training.\nThe fine-tuning learning rate is the original learning rate used for\npretraining multiplied by this value.\n\nBy default, the learning rate multiplier is the 0.05, 0.1, or 0.2\ndepending on final `batch_size` (larger learning rates tend to\nperform better with larger batch sizes). We recommend experimenting\nwith values in the range 0.02 to 0.2 to see what produces the best\nresults.\n\n\n- `model`: The name of the base model to fine-tune. You can select one of \"ada\",\n\"babbage\", \"curie\", \"davinci\", or a fine-tuned model created after 2022-04-21 and before 2023-08-22.\nTo learn more about these models, see the\n[Models](https://platform.openai.com/docs/models) documentation.\n\n\n- `prompt_loss_weight`: The weight to use for loss on the prompt tokens. This controls how\nmuch the model tries to learn to generate the prompt (as compared\nto the completion which always has a weight of 1.0), and can add\na stabilizing effect to training when completions are short.\n\nIf prompts are extremely long (relative to completions), it may make\nsense to reduce this weight so as to avoid over-prioritizing\nlearning the prompt.\n\n\n- `suffix`: A string of up to 40 characters that will be added to your fine-tuned model name.\n\nFor example, a `suffix` of \"custom-model-name\" would produce a model name like `ada:ft-your-org:custom-model-name-2022-02-15-04-21-04`.\n\n\n- `validation_file`: The ID of an uploaded file that contains validation data.\n\nIf you provide this file, the data is used to generate validation\nmetrics periodically during fine-tuning. These metrics can be viewed in\nthe [fine-tuning results file](https://platform.openai.com/docs/guides/legacy-fine-tuning/analyzing-your-fine-tuned-model).\nYour train and validation data should be mutually exclusive.\n\nYour dataset must be formatted as a JSONL file, where each validation\nexample is a JSON object with the keys \"prompt\" and \"completion\".\nAdditionally, you must upload your file with the purpose `fine-tune`.\n\nSee the [fine-tuning guide](https://platform.openai.com/docs/guides/legacy-fine-tuning/creating-training-data) for more details.\n\n\n*Example*: `\"file-abc123\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTunes.html#create_fine_tune/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTunes.create_fine_tune/2","type":"function"},{"doc":"Get fine-grained status updates for a fine-tune job.\n\n\nEndpoint: `https://api.openai.com/v1/fine-tunes/{fine_tune_id}/events`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tunes\n\n---\n\n#","ref":"ExOpenAI.FineTunes.html#list_fine_tune_events/2","title":"ExOpenAI.FineTunes.list_fine_tune_events/2","type":"function"},{"doc":"- `fine_tune_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTunes.html#list_fine_tune_events/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTunes.list_fine_tune_events/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `stream`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTunes.html#list_fine_tune_events/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTunes.list_fine_tune_events/2","type":"function"},{"doc":"List your organization's fine-tuning jobs\n\n\nEndpoint: `https://api.openai.com/v1/fine-tunes`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tunes\n\n---\n\n#","ref":"ExOpenAI.FineTunes.html#list_fine_tunes/1","title":"ExOpenAI.FineTunes.list_fine_tunes/1","type":"function"},{"doc":"#","ref":"ExOpenAI.FineTunes.html#list_fine_tunes/1-required-arguments","title":"Required Arguments: - ExOpenAI.FineTunes.list_fine_tunes/1","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTunes.html#list_fine_tunes/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTunes.list_fine_tunes/1","type":"function"},{"doc":"Gets info about the fine-tune job.\n\n[Learn more about fine-tuning](https://platform.openai.com/docs/guides/legacy-fine-tuning)\n\n\nEndpoint: `https://api.openai.com/v1/fine-tunes/{fine_tune_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tunes\n\n---\n\n#","ref":"ExOpenAI.FineTunes.html#retrieve_fine_tune/2","title":"ExOpenAI.FineTunes.retrieve_fine_tune/2","type":"function"},{"doc":"- `fine_tune_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTunes.html#retrieve_fine_tune/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTunes.retrieve_fine_tune/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTunes.html#retrieve_fine_tune/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTunes.retrieve_fine_tune/2","type":"function"},{"doc":"Modules for interacting with the `fine_tuning` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/fine_tuning","ref":"ExOpenAI.FineTuning.html","title":"ExOpenAI.FineTuning","type":"module"},{"doc":"Immediately cancel a fine-tune job.\n\n\nEndpoint: `https://api.openai.com/v1/fine_tuning/jobs/{fine_tuning_job_id}/cancel`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tuning\n\n---\n\n#","ref":"ExOpenAI.FineTuning.html#cancel_fine_tuning_job/2","title":"ExOpenAI.FineTuning.cancel_fine_tuning_job/2","type":"function"},{"doc":"- `fine_tuning_job_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTuning.html#cancel_fine_tuning_job/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTuning.cancel_fine_tuning_job/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTuning.html#cancel_fine_tuning_job/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTuning.cancel_fine_tuning_job/2","type":"function"},{"doc":"Creates a job that fine-tunes a specified model from a given dataset.\n\nResponse includes details of the enqueued job including job status and the name of the fine-tuned models once complete.\n\n[Learn more about fine-tuning](https://platform.openai.com/docs/guides/fine-tuning)\n\n\nEndpoint: `https://api.openai.com/v1/fine_tuning/jobs`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tuning\n\n---\n\n#","ref":"ExOpenAI.FineTuning.html#create_fine_tuning_job/3","title":"ExOpenAI.FineTuning.create_fine_tuning_job/3","type":"function"},{"doc":"- `model`: The name of the model to fine-tune. You can select one of the\n[supported models](https://platform.openai.com/docs/guides/fine-tuning/what-models-can-be-fine-tuned).\n\n\n- `training_file`: The ID of an uploaded file that contains training data.\n\nSee [upload file](https://platform.openai.com/docs/api-reference/files/upload) for how to upload a file.\n\nYour dataset must be formatted as a JSONL file. Additionally, you must upload your file with the purpose `fine-tune`.\n\nSee the [fine-tuning guide](https://platform.openai.com/docs/guides/fine-tuning) for more details.\n\n\n*Example*: `file-abc123`\n\n\n#","ref":"ExOpenAI.FineTuning.html#create_fine_tuning_job/3-required-arguments","title":"Required Arguments: - ExOpenAI.FineTuning.create_fine_tuning_job/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `hyperparameters`: The hyperparameters used for the fine-tuning job.\n\n- `suffix`: A string of up to 18 characters that will be added to your fine-tuned model name.\n\nFor example, a `suffix` of \"custom-model-name\" would produce a model name like `ft:gpt-3.5-turbo:openai:custom-model-name:7p4lURel`.\n\n\n- `validation_file`: The ID of an uploaded file that contains validation data.\n\nIf you provide this file, the data is used to generate validation\nmetrics periodically during fine-tuning. These metrics can be viewed in\nthe fine-tuning results file.\nThe same data should not be present in both train and validation files.\n\nYour dataset must be formatted as a JSONL file. You must upload your file with the purpose `fine-tune`.\n\nSee the [fine-tuning guide](https://platform.openai.com/docs/guides/fine-tuning) for more details.\n\n\n*Example*: `\"file-abc123\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTuning.html#create_fine_tuning_job/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTuning.create_fine_tuning_job/3","type":"function"},{"doc":"Get status updates for a fine-tuning job.\n\n\nEndpoint: `https://api.openai.com/v1/fine_tuning/jobs/{fine_tuning_job_id}/events`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tuning\n\n---\n\n#","ref":"ExOpenAI.FineTuning.html#list_fine_tuning_events/2","title":"ExOpenAI.FineTuning.list_fine_tuning_events/2","type":"function"},{"doc":"- `fine_tuning_job_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTuning.html#list_fine_tuning_events/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTuning.list_fine_tuning_events/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `after`\n\n- `limit`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTuning.html#list_fine_tuning_events/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTuning.list_fine_tuning_events/2","type":"function"},{"doc":"List your organization's fine-tuning jobs\n\n\nEndpoint: `https://api.openai.com/v1/fine_tuning/jobs`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tuning\n\n---\n\n#","ref":"ExOpenAI.FineTuning.html#list_paginated_fine_tuning_jobs/1","title":"ExOpenAI.FineTuning.list_paginated_fine_tuning_jobs/1","type":"function"},{"doc":"#","ref":"ExOpenAI.FineTuning.html#list_paginated_fine_tuning_jobs/1-required-arguments","title":"Required Arguments: - ExOpenAI.FineTuning.list_paginated_fine_tuning_jobs/1","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `after`\n\n- `limit`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTuning.html#list_paginated_fine_tuning_jobs/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTuning.list_paginated_fine_tuning_jobs/1","type":"function"},{"doc":"Get info about a fine-tuning job.\n\n[Learn more about fine-tuning](https://platform.openai.com/docs/guides/fine-tuning)\n\n\nEndpoint: `https://api.openai.com/v1/fine_tuning/jobs/{fine_tuning_job_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/fine_tuning\n\n---\n\n#","ref":"ExOpenAI.FineTuning.html#retrieve_fine_tuning_job/2","title":"ExOpenAI.FineTuning.retrieve_fine_tuning_job/2","type":"function"},{"doc":"- `fine_tuning_job_id`\n\n*Example*: `ft-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.FineTuning.html#retrieve_fine_tuning_job/2-required-arguments","title":"Required Arguments: - ExOpenAI.FineTuning.retrieve_fine_tuning_job/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.FineTuning.html#retrieve_fine_tuning_job/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.FineTuning.retrieve_fine_tuning_job/2","type":"function"},{"doc":"Modules for interacting with the `images` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/images","ref":"ExOpenAI.Images.html","title":"ExOpenAI.Images","type":"module"},{"doc":"Creates an image given a prompt.\n\nEndpoint: `https://api.openai.com/v1/images/generations`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/images\n\n---\n\n#","ref":"ExOpenAI.Images.html#create_image/2","title":"ExOpenAI.Images.create_image/2","type":"function"},{"doc":"- `prompt`: A text description of the desired image(s). The maximum length is 1000 characters for `dall-e-2` and 4000 characters for `dall-e-3`.\n\n*Example*: `A cute baby sea otter`\n\n\n#","ref":"ExOpenAI.Images.html#create_image/2-required-arguments","title":"Required Arguments: - ExOpenAI.Images.create_image/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `model`: The model to use for image generation.\n\n- `n`: The number of images to generate. Must be between 1 and 10. For `dall-e-3`, only `n=1` is supported.\n\n*Example*: `1`\n\n- `quality`: The quality of the image that will be generated. `hd` creates images with finer details and greater consistency across the image. This param is only supported for `dall-e-3`.\n\n*Example*: `\"standard\"`\n\n- `response_format`: The format in which the generated images are returned. Must be one of `url` or `b64_json`.\n\n*Example*: `\"url\"`\n\n- `size`: The size of the generated images. Must be one of `256x256`, `512x512`, or `1024x1024` for `dall-e-2`. Must be one of `1024x1024`, `1792x1024`, or `1024x1792` for `dall-e-3` models.\n\n*Example*: `\"1024x1024\"`\n\n- `style`: The style of the generated images. Must be one of `vivid` or `natural`. Vivid causes the model to lean towards generating hyper-real and dramatic images. Natural causes the model to produce more natural, less hyper-real looking images. This param is only supported for `dall-e-3`.\n\n*Example*: `\"vivid\"`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Images.html#create_image/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Images.create_image/2","type":"function"},{"doc":"Creates an edited or extended image given an original image and a prompt.\n\nEndpoint: `https://api.openai.com/v1/images/edits`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/images\n\n---\n\n#","ref":"ExOpenAI.Images.html#create_image_edit/3","title":"ExOpenAI.Images.create_image_edit/3","type":"function"},{"doc":"- `image`: The image to edit. Must be a valid PNG file, less than 4MB, and square. If mask is not provided, image must have transparency, which will be used as the mask.\n\n- `prompt`: A text description of the desired image(s). The maximum length is 1000 characters.\n\n*Example*: `A cute baby sea otter wearing a beret`\n\n\n#","ref":"ExOpenAI.Images.html#create_image_edit/3-required-arguments","title":"Required Arguments: - ExOpenAI.Images.create_image_edit/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `mask`: An additional image whose fully transparent areas (e.g. where alpha is zero) indicate where `image` should be edited. Must be a valid PNG file, less than 4MB, and have the same dimensions as `image`.\n\n- `model`: The model to use for image generation. Only `dall-e-2` is supported at this time.\n\n- `n`: The number of images to generate. Must be between 1 and 10.\n\n*Example*: `1`\n\n- `response_format`: The format in which the generated images are returned. Must be one of `url` or `b64_json`.\n\n*Example*: `\"url\"`\n\n- `size`: The size of the generated images. Must be one of `256x256`, `512x512`, or `1024x1024`.\n\n*Example*: `\"1024x1024\"`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Images.html#create_image_edit/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Images.create_image_edit/3","type":"function"},{"doc":"Creates a variation of a given image.\n\nEndpoint: `https://api.openai.com/v1/images/variations`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/images\n\n---\n\n#","ref":"ExOpenAI.Images.html#create_image_variation/2","title":"ExOpenAI.Images.create_image_variation/2","type":"function"},{"doc":"- `image`: The image to use as the basis for the variation(s). Must be a valid PNG file, less than 4MB, and square.\n\n\n#","ref":"ExOpenAI.Images.html#create_image_variation/2-required-arguments","title":"Required Arguments: - ExOpenAI.Images.create_image_variation/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `model`: The model to use for image generation. Only `dall-e-2` is supported at this time.\n\n- `n`: The number of images to generate. Must be between 1 and 10. For `dall-e-3`, only `n=1` is supported.\n\n*Example*: `1`\n\n- `response_format`: The format in which the generated images are returned. Must be one of `url` or `b64_json`.\n\n*Example*: `\"url\"`\n\n- `size`: The size of the generated images. Must be one of `256x256`, `512x512`, or `1024x1024`.\n\n*Example*: `\"1024x1024\"`\n\n- `user`: A unique identifier representing your end-user, which can help OpenAI to monitor and detect abuse. [Learn more](https://platform.openai.com/docs/guides/safety-best-practices/end-user-ids).\n\n\n*Example*: `\"user-1234\"`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Images.html#create_image_variation/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Images.create_image_variation/2","type":"function"},{"doc":"Modules for interacting with the `models` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/models","ref":"ExOpenAI.Models.html","title":"ExOpenAI.Models","type":"module"},{"doc":"Delete a fine-tuned model. You must have the Owner role in your organization to delete a model.\n\nEndpoint: `https://api.openai.com/v1/models/{model}`\n\nMethod: DELETE\n\nDocs: https://platform.openai.com/docs/api-reference/models\n\n---\n\n#","ref":"ExOpenAI.Models.html#delete_model/2","title":"ExOpenAI.Models.delete_model/2","type":"function"},{"doc":"- `model`\n\n*Example*: `ft:gpt-3.5-turbo:acemeco:suffix:abc123`\n\n\n#","ref":"ExOpenAI.Models.html#delete_model/2-required-arguments","title":"Required Arguments: - ExOpenAI.Models.delete_model/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Models.html#delete_model/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Models.delete_model/2","type":"function"},{"doc":"Lists the currently available models, and provides basic information about each one such as the owner and availability.\n\nEndpoint: `https://api.openai.com/v1/models`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/models\n\n---\n\n#","ref":"ExOpenAI.Models.html#list_models/1","title":"ExOpenAI.Models.list_models/1","type":"function"},{"doc":"#","ref":"ExOpenAI.Models.html#list_models/1-required-arguments","title":"Required Arguments: - ExOpenAI.Models.list_models/1","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Models.html#list_models/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.Models.list_models/1","type":"function"},{"doc":"Retrieves a model instance, providing basic information about the model such as the owner and permissioning.\n\nEndpoint: `https://api.openai.com/v1/models/{model}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/models\n\n---\n\n#","ref":"ExOpenAI.Models.html#retrieve_model/2","title":"ExOpenAI.Models.retrieve_model/2","type":"function"},{"doc":"- `model`\n\n*Example*: `gpt-3.5-turbo`\n\n\n#","ref":"ExOpenAI.Models.html#retrieve_model/2-required-arguments","title":"Required Arguments: - ExOpenAI.Models.retrieve_model/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Models.html#retrieve_model/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Models.retrieve_model/2","type":"function"},{"doc":"Modules for interacting with the `moderations` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/moderations","ref":"ExOpenAI.Moderations.html","title":"ExOpenAI.Moderations","type":"module"},{"doc":"Classifies if text violates OpenAI's Content Policy\n\nEndpoint: `https://api.openai.com/v1/moderations`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/moderations\n\n---\n\n#","ref":"ExOpenAI.Moderations.html#create_moderation/2","title":"ExOpenAI.Moderations.create_moderation/2","type":"function"},{"doc":"- `input`: The input text to classify\n\n\n#","ref":"ExOpenAI.Moderations.html#create_moderation/2-required-arguments","title":"Required Arguments: - ExOpenAI.Moderations.create_moderation/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `model`: Two content moderations models are available: `text-moderation-stable` and `text-moderation-latest`.\n\nThe default is `text-moderation-latest` which will be automatically upgraded over time. This ensures you are always using our most accurate model. If you use `text-moderation-stable`, we will provide advanced notice before updating the model. Accuracy of `text-moderation-stable` may be slightly lower than for `text-moderation-latest`.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Moderations.html#create_moderation/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Moderations.create_moderation/2","type":"function"},{"doc":"","ref":"ExOpenAI.StreamingClient.html","title":"ExOpenAI.StreamingClient","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExOpenAI.StreamingClient.html#child_spec/1","title":"ExOpenAI.StreamingClient.child_spec/1","type":"function"},{"doc":"Forwards the given response back to the receiver\nIf receiver is a PID, will use GenServer.cast to send\nIf receiver is a function, will call the function directly","ref":"ExOpenAI.StreamingClient.html#forward_response/2","title":"ExOpenAI.StreamingClient.forward_response/2","type":"function"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#handle_chunk/2","title":"ExOpenAI.StreamingClient.handle_chunk/2","type":"function"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#c:handle_data/2","title":"ExOpenAI.StreamingClient.handle_data/2","type":"callback"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#c:handle_error/2","title":"ExOpenAI.StreamingClient.handle_error/2","type":"callback"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#c:handle_finish/1","title":"ExOpenAI.StreamingClient.handle_finish/1","type":"callback"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#init/1","title":"ExOpenAI.StreamingClient.init/1","type":"function"},{"doc":"","ref":"ExOpenAI.StreamingClient.html#start_link/2","title":"ExOpenAI.StreamingClient.start_link/2","type":"function"},{"doc":"Modules for interacting with the `threads` group of OpenAI APIs\n\nAPI Reference: https://platform.openai.com/docs/api-reference/threads","ref":"ExOpenAI.Threads.html","title":"ExOpenAI.Threads","type":"module"},{"doc":"Cancels a run that is `in_progress`.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}/cancel`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#cancel_run/3","title":"ExOpenAI.Threads.cancel_run/3","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n\n#","ref":"ExOpenAI.Threads.html#cancel_run/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.cancel_run/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#cancel_run/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.cancel_run/3","type":"function"},{"doc":"Create a message.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#create_message/4","title":"ExOpenAI.Threads.create_message/4","type":"function"},{"doc":"- `thread_id`\n\n- `content`: The content of the message.\n\n- `role`: The role of the entity that is creating the message. Currently only `user` is supported.\n\n\n#","ref":"ExOpenAI.Threads.html#create_message/4-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.create_message/4","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `file_ids`: A list of [File](https://platform.openai.com/docs/api-reference/files) IDs that the message should use. There can be a maximum of 10 files attached to a message. Useful for tools like `retrieval` and `code_interpreter` that can access and use files.\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#create_message/4-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.create_message/4","type":"function"},{"doc":"Create a run.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#create_run/3","title":"ExOpenAI.Threads.create_run/3","type":"function"},{"doc":"- `thread_id`\n\n- `assistant_id`: The ID of the [assistant](https://platform.openai.com/docs/api-reference/assistants) to use to execute this run.\n\n\n#","ref":"ExOpenAI.Threads.html#create_run/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.create_run/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `instructions`: Override the default system message of the assistant. This is useful for modifying the behavior on a per-run basis.\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `model`: The ID of the [Model](https://platform.openai.com/docs/api-reference/models) to be used to execute this run. If a value is provided here, it will override the model associated with the assistant. If not, the model associated with the assistant will be used.\n\n- `tools`: Override the tools the assistant can use for this run. This is useful for modifying the behavior on a per-run basis.\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#create_run/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.create_run/3","type":"function"},{"doc":"Create a thread.\n\nEndpoint: `https://api.openai.com/v1/threads`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#create_thread/1","title":"ExOpenAI.Threads.create_thread/1","type":"function"},{"doc":"#","ref":"ExOpenAI.Threads.html#create_thread/1-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.create_thread/1","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `messages`: A list of [messages](https://platform.openai.com/docs/api-reference/messages) to start the thread with.\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#create_thread/1-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.create_thread/1","type":"function"},{"doc":"Create a thread and run it in one request.\n\nEndpoint: `https://api.openai.com/v1/threads/runs`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#create_thread_and_run/2","title":"ExOpenAI.Threads.create_thread_and_run/2","type":"function"},{"doc":"- `assistant_id`: The ID of the [assistant](https://platform.openai.com/docs/api-reference/assistants) to use to execute this run.\n\n\n#","ref":"ExOpenAI.Threads.html#create_thread_and_run/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.create_thread_and_run/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `instructions`: Override the default system message of the assistant. This is useful for modifying the behavior on a per-run basis.\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `model`: The ID of the [Model](https://platform.openai.com/docs/api-reference/models) to be used to execute this run. If a value is provided here, it will override the model associated with the assistant. If not, the model associated with the assistant will be used.\n\n- `thread`: If no thread is provided, an empty thread will be created.\n\n- `tools`: Override the tools the assistant can use for this run. This is useful for modifying the behavior on a per-run basis.\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#create_thread_and_run/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.create_thread_and_run/2","type":"function"},{"doc":"Delete a thread.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}`\n\nMethod: DELETE\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#delete_thread/2","title":"ExOpenAI.Threads.delete_thread/2","type":"function"},{"doc":"- `thread_id`\n\n\n#","ref":"ExOpenAI.Threads.html#delete_thread/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.delete_thread/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#delete_thread/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.delete_thread/2","type":"function"},{"doc":"Retrieve a message.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages/{message_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#get_message/3","title":"ExOpenAI.Threads.get_message/3","type":"function"},{"doc":"- `thread_id`\n\n- `message_id`\n\n\n#","ref":"ExOpenAI.Threads.html#get_message/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.get_message/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#get_message/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.get_message/3","type":"function"},{"doc":"Retrieves a message file.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages/{message_id}/files/{file_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#get_message_file/4","title":"ExOpenAI.Threads.get_message_file/4","type":"function"},{"doc":"- `thread_id`\n\n*Example*: `thread_AF1WoRqd3aJAHsqc9NY7iL8F`\n\n- `message_id`\n\n*Example*: `msg_AF1WoRqd3aJAHsqc9NY7iL8F`\n\n- `file_id`\n\n*Example*: `file-AF1WoRqd3aJAHsqc9NY7iL8F`\n\n\n#","ref":"ExOpenAI.Threads.html#get_message_file/4-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.get_message_file/4","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#get_message_file/4-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.get_message_file/4","type":"function"},{"doc":"Retrieves a run.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#get_run/3","title":"ExOpenAI.Threads.get_run/3","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n\n#","ref":"ExOpenAI.Threads.html#get_run/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.get_run/3","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#get_run/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.get_run/3","type":"function"},{"doc":"Retrieves a run step.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}/steps/{step_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#get_run_step/4","title":"ExOpenAI.Threads.get_run_step/4","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n- `step_id`\n\n\n#","ref":"ExOpenAI.Threads.html#get_run_step/4-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.get_run_step/4","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#get_run_step/4-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.get_run_step/4","type":"function"},{"doc":"Retrieves a thread.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#get_thread/2","title":"ExOpenAI.Threads.get_thread/2","type":"function"},{"doc":"- `thread_id`\n\n\n#","ref":"ExOpenAI.Threads.html#get_thread/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.get_thread/2","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#get_thread/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.get_thread/2","type":"function"},{"doc":"Returns a list of message files.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages/{message_id}/files`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#list_message_files/3","title":"ExOpenAI.Threads.list_message_files/3","type":"function"},{"doc":"- `thread_id`\n\n- `message_id`\n\n\n#","ref":"ExOpenAI.Threads.html#list_message_files/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.list_message_files/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#list_message_files/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.list_message_files/3","type":"function"},{"doc":"Returns a list of messages for a given thread.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#list_messages/2","title":"ExOpenAI.Threads.list_messages/2","type":"function"},{"doc":"- `thread_id`\n\n\n#","ref":"ExOpenAI.Threads.html#list_messages/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.list_messages/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#list_messages/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.list_messages/2","type":"function"},{"doc":"Returns a list of run steps belonging to a run.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}/steps`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#list_run_steps/3","title":"ExOpenAI.Threads.list_run_steps/3","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n\n#","ref":"ExOpenAI.Threads.html#list_run_steps/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.list_run_steps/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#list_run_steps/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.list_run_steps/3","type":"function"},{"doc":"Returns a list of runs belonging to a thread.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs`\n\nMethod: GET\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#list_runs/2","title":"ExOpenAI.Threads.list_runs/2","type":"function"},{"doc":"- `thread_id`\n\n\n#","ref":"ExOpenAI.Threads.html#list_runs/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.list_runs/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `limit`\n\n- `order`\n\n- `after`\n\n- `before`\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#list_runs/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.list_runs/2","type":"function"},{"doc":"Modifies a message.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/messages/{message_id}`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#modify_message/3","title":"ExOpenAI.Threads.modify_message/3","type":"function"},{"doc":"- `thread_id`\n\n- `message_id`\n\n\n#","ref":"ExOpenAI.Threads.html#modify_message/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.modify_message/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#modify_message/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.modify_message/3","type":"function"},{"doc":"Modifies a run.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#modify_run/3","title":"ExOpenAI.Threads.modify_run/3","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n\n#","ref":"ExOpenAI.Threads.html#modify_run/3-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.modify_run/3","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#modify_run/3-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.modify_run/3","type":"function"},{"doc":"Modifies a thread.\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#modify_thread/2","title":"ExOpenAI.Threads.modify_thread/2","type":"function"},{"doc":"- `thread_id`\n\n\n#","ref":"ExOpenAI.Threads.html#modify_thread/2-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.modify_thread/2","type":"function"},{"doc":"- `stream_to`: PID or function of where to stream content to\n\n- `metadata`: Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format. Keys can be a maximum of 64 characters long and values can be a maxium of 512 characters long.\n\n\n- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#modify_thread/2-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.modify_thread/2","type":"function"},{"doc":"When a run has the `status: \"requires_action\"` and `required_action.type` is `submit_tool_outputs`, this endpoint can be used to submit the outputs from the tool calls once they're all completed. All outputs must be submitted in a single request.\n\n\nEndpoint: `https://api.openai.com/v1/threads/{thread_id}/runs/{run_id}/submit_tool_outputs`\n\nMethod: POST\n\nDocs: https://platform.openai.com/docs/api-reference/threads\n\n---\n\n#","ref":"ExOpenAI.Threads.html#submit_tool_ouputs_to_run/4","title":"ExOpenAI.Threads.submit_tool_ouputs_to_run/4","type":"function"},{"doc":"- `thread_id`\n\n- `run_id`\n\n- `tool_outputs`: A list of tools for which the outputs are being submitted.\n\n\n#","ref":"ExOpenAI.Threads.html#submit_tool_ouputs_to_run/4-required-arguments","title":"Required Arguments: - ExOpenAI.Threads.submit_tool_ouputs_to_run/4","type":"function"},{"doc":"- `openai_api_key`: OpenAI API key to pass directly. If this is specified, it will override the `api_key` config value.\n\n- `openai_organization_key`: OpenAI API key to pass directly. If this is specified, it will override the `organization_key` config value.","ref":"ExOpenAI.Threads.html#submit_tool_ouputs_to_run/4-optional-arguments","title":"Optional Arguments: - ExOpenAI.Threads.submit_tool_ouputs_to_run/4","type":"function"},{"doc":"Updates OpenAI API documentation files","ref":"Mix.Tasks.UpdateOpenaiDocs.html","title":"mix update_openai_docs","type":"task"}]}